/************************************************************
Synchronizes the searchbox with a search engine in firefox
Copyright (C) 2005  Angus McBride

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
************************************************************/

/*
This contains all of the default search engines that come as
standard with search synchronizer
*/

function get_defaults(prefs,se) {
	//Where all the enabled/disabled are stored
	var prefix = "defaults.";

	/*
	Everything works in the form:
	if search engine enabled in preferences then
		add that search engine object to the end of the array
	*/


	if(prefs.getBoolPref(prefix+"google"))
		se[se.length] = new sengine("Google",/^http:\/\/.+\.google\..+\/(search|images|groups|news|froogle)\?.*q=/i,/q=([^&]+)/);

	if(prefs.getBoolPref(prefix+"yahoo"))
		se[se.length] = new sengine("Yahoo",/^http:\/\/.{0,4}(((img|video|news)\.)?search|shopping)\.yahoo\.com\/search.*\?.*p=/i,/p=([^&]+)/);

	if(prefs.getBoolPref(prefix+"msn"))
		se[se.length] = new sengine("MSN",/^http:\/\/search\.msn\.com(|\/images|\/news)\/results\.aspx\?.*q=/i,/q=([^&]+)/);

	if(prefs.getBoolPref(prefix+"wikipedia")) {
		se[se.length] = new sengine("wiki",/^http:\/\/.{0,2}\.wikipedia\.org\/wiki\/[^?]+$/i,/\/(\w+)$/);
		se[se.length] = new sengine("wikisearch",/^http:\/\/.{0,2}\.wikipedia\.org\/wiki\/Special:Search\?search=/i,/search=([^&]+)/);
	}

	if(prefs.getBoolPref(prefix+"dictionary.com"))
		se[se.length] = new sengine("Dictionary.com",/^http:\/\/dictionary\.reference\.com\/search\?.*q=/i,/q=([^&]+)/);

	if(prefs.getBoolPref(prefix+"thesaurus.com"))
		se[se.length] = new sengine("Thesaurus.com",/^http:\/\/thesaurus\.reference\.com\/search\?.*q=/i,/q=([^&]+)/);

	if(prefs.getBoolPref(prefix+"altavista"))
		se[se.length] = new sengine("altavista",/^http:\/\/.{1,4}\.altavista\.com\/(web|image|audio|video|news)\/results\?.*q=/i,/q=([^&]+)/);

	if(prefs.getBoolPref(prefix+"a9"))
		se[se.length] = new sengine("a9",/^http:\/\/.{0,4}a9\.com\/[^\/]+$/i,/\/([^\/]+)$/);

	if(prefs.getBoolPref(prefix+"mozillaupdate"))
		se[se.length] = new sengine("mozillaupdate",/^https:\/\/addons\.mozilla\.org\/quicksearch\.php\?.*q=/i,/q=([^&]+)/);

	if(prefs.getBoolPref(prefix+"askjeeves"))
		se[se.length] = new sengine("askjeeves",/^http:\/\/(web|pictures|news)\.ask\.[^\/]+\/(web|pictures|news|uk)\?.*q=/i,/q=([^&]+)/);

	if(prefs.getBoolPref(prefix+"dogpile"))
		se[se.length] = new sengine("dogpile",/^http:\/\/\w{0,5}\.?dogpile\.[^\/]+\/(info|uk)\.dogpl\/search\/(web|images|audio|multimedia|news)\/[^\/]+$/i , /\/([^\/?#]+)(\?.*)?#?$/);

	if(prefs.getBoolPref(prefix+"webcrawler"))	
		se[se.length] = new sengine("webcrawler",/^http:\/\/msxml\.webcrawler\.[^\/]+\/info\.wbcrwl\/search\/(web|images|audio|multimedia|news)\/[^\/]+$/i , /\/([^\/?#]+)(\?.*)?#?$/);		

	if(prefs.getBoolPref(prefix+"ebay")){
		se[se.length] = new sengine("ebay1",/^http:\/\/search\.ebay\.[^\/]+\/\w[^?]*$/i , /\/([^_\/]+)_[^_\/]+$/);		
		se[se.length] = new sengine("ebay2",/^http:\/\/search\.ebay\.com\/search\/search\.dll\?.*satitle=/i , /satitle=([^&]+)/);
	}
	if(prefs.getBoolPref(prefix+"bbc"))	
		se[se.length] = new sengine("bbc",/^http:\/\/www\.bbc\.co\.uk\/cgi-bin\/search\/results\.pl\?.*q=/i , /q=([^&]+)/);		

	if(prefs.getBoolPref(prefix+"lycos"))	
		se[se.length] = new sengine("lycos",/^http:\/\/search\.lycos\..+\?.*query=/i , /query=([^&]+)/);		

	if(prefs.getBoolPref(prefix+"overture"))	
		se[se.length] = new sengine("overture",/http:\/\/\w*\.?overture\.com\/d\/search\/\?.*Keywords=/i , /Keywords=([^&]+)/);		

	if(prefs.getBoolPref(prefix+"trovando"))	
		se[se.length] = new sengine("trovando",/^http:\/\/www\.trovando\.it\/default2\.asp\?.*q=/i , /q=([^&]+)/);		

	return se;
}