//SEARCH SYNCHRONIZER

var ssPrefs   = getSSPrefs();
var ssGlobals = new Array();
ssGlobals['custom'] = new Array();

function getSSPrefs() {
	//Get preferences object
	var ssallprefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService);

	return ssallprefs.getBranch("extensions.searchsynchronizer.");
}

//Function called when the page loads
function pageLoad() {
	addDefaults();
	loadUserEngines();
}

////////////////////////////////////////////////////////////////////////////////

function addDefaults() {
	const defListObj = document.getElementById("defaultlist");	//The listbox object
	const searchengines = new Array("google","yahoo","msn","wikipedia","askjeeves","dogpile","ebay",
		"overture","dictionary.com","thesaurus.com","altavista","a9","mozillaupdate","webcrawler","bbc","lycos","trovando"); 			//All of the search engine codes
	const prefix = "defaults."; 		//The thing that precedes all of the default preferences

	const searchnames = document.getElementById("searchengines-sb");

	//Declare variables for loop
	var se;			//used to hold the search engine name in loop
	var listItem;		//Used to hold list item in loop
	var i;			//Used to control loop

	for(i=0;i<searchengines.length;i++) {	//Loop through each search engine
		se = searchengines[i];		
		
		listItem = defListObj.appendItem(searchnames.getString(se), se);

		if(ssPrefs.getBoolPref(prefix+se)) {
			listItem.style.color = "black";
			listItem.setAttribute("enabled", true);
		}
		else {
			listItem.style.color = "#999";
			listItem.setAttribute("enabled", false);	
		}
	}
	defaultSelected();
}

function defaultSelected() {
	var selectedItem = document.getElementById("defaultlist").selectedItem;
	var enableButton = document.getElementById("searchsynchronizerEnable");
	var disableButton = document.getElementById("searchsynchronizerDisable");

	if(selectedItem) {
		if(selectedItem.getAttribute("enabled")=="true") {
			enableButton.disabled = true;
			disableButton.disabled = false;
			disableButton.focus();
		}
		else {
			enableButton.disabled = false;
			disableButton.disabled = true;
			enableButton.focus();
		}
	}
	else {
		enableButton.disabled = true;
		disableButton.disabled = true;
	}
}

function enableDefault() {
	var selectedItem = document.getElementById("defaultlist").selectedItem;
	if(selectedItem) {
		selectedItem.style.color="black";
		selectedItem.setAttribute("enabled",true);
		defaultSelected();
	}
}
function disableDefault() {
	var selectedItem = document.getElementById("defaultlist").selectedItem;
	if(selectedItem) {
		selectedItem.style.color="#999";
		selectedItem.setAttribute("enabled",false);
		defaultSelected();
	}
}


////////////////////////////////////////////////////////////////////////////


function loadUserEngines() {
	var num = ssPrefs.getIntPref("numengines");

	if(!num) {
		return true;
	}
	else {
		var i,name,test,find,lastadded;
		for(i=0;i<num;i++) {
			name = ssPrefs.getCharPref("custom."+i+".name");
			test = ssPrefs.getCharPref("custom."+i+".test");
			find = ssPrefs.getCharPref("custom."+i+".find");
			lastadded = addUserEngine(name,test,find);
		}
		//todo - Some kinda code to set focus
		return true;
	}
	
}

function customSelected() {
	const edit = document.getElementById("searchsynchronizerCustomEdit");
	const del = document.getElementById("searchsynchronizerCustomDelete");

	edit.disabled = false;
	del.disabled = false;
}

/*
function defaultSelected() {
	var selectedItem = document.getElementById("defaultlist").selectedItem;
	var Button = document.getElementById("searchsynchronizerEnable");
	var disableButton = document.getElementById("searchsynchronizerDisable");

	if(selectedItem) {
		if(selectedItem.getAttribute("enabled")=="true") {
			enableButton.disabled = true;
			disableButton.disabled = false;
			disableButton.focus();
		}
		else {
			enableButton.disabled = false;
			disableButton.disabled = true;
			enableButton.focus();
		}
	}
	else {
		enableButton.disabled = true;
		disableButton.disabled = true;
	}
}
*/

function addUserEngine(name,test,find) {
	var engineList = document.getElementById("customList");

        var listItem = document.createElement("listitem");

        var listCell = document.createElement("listcell");
        listCell.setAttribute("label", name);
        listItem.appendChild(listCell);

        listCell = document.createElement("listcell");
        listCell.setAttribute("label", test);
        listItem.appendChild(listCell);

        listCell = document.createElement("listcell");
        listCell.setAttribute("label", find);
        listItem.appendChild(listCell);

        return engineList.appendChild(listItem);
}

function customNew() {
	window.openDialog("chrome://searchsynchronizer/content/options/custom.xul", "searchsynchronizer-custom-dialog", "centerscreen,chrome,modal,resizable", "new");

	if(ssGlobals['custom']['name']) {
		addUserEngine(ssGlobals['custom']['name'],ssGlobals['custom']['test'],ssGlobals['custom']['find']);
	}	
}

function customEdit() {
    const listBox    = document.getElementById("customList");
    const selectedItem = listBox.selectedItem;

    // If an option is selected
    if(selectedItem)
    {
        window.openDialog("chrome://searchsynchronizer/content/options/custom.xul", "webdeveloper-resize-dialog", "centerscreen,chrome,modal", "edit", selectedItem.childNodes[0].getAttribute("label"), selectedItem.childNodes[1].getAttribute("label"), selectedItem.childNodes[2].getAttribute("label"));

        // If the description, height and width are set
        if(ssGlobals['custom']['name'])
        {
            var listCell = document.createElement("listcell");

            removeAllChildNodes(selectedItem);

            listCell.setAttribute("label",ssGlobals['custom']['name'] );
            selectedItem.appendChild(listCell);

            listCell = document.createElement("listcell");
            listCell.setAttribute("label", ssGlobals['custom']['test']);
            selectedItem.appendChild(listCell);

            listCell = document.createElement("listcell");
            listCell.setAttribute("label", ssGlobals['custom']['find']);
            selectedItem.appendChild(listCell);
        }
    }
}

function customDelete()
{
    const stringBundle = document.getElementById("searchsynchronizer-string-bundle");
    const listBox      = document.getElementById("customList");
    const selectedItem = listBox.selectedItem;

    // If an item is selected and the deletion is confirmed
    if(selectedItem && confirm(stringBundle.getString("searchsynchronizer.options.confirmdelete")))
    {
        listBox.removeChild(selectedItem);
    }
}

// Removes all child nodes from a node
function removeAllChildNodes(node)
{
    var childNodes = node.childNodes;

    // Loop through the child nodes
    for(var i = 0; i < childNodes.length; i++)
    {
        node.removeChild(childNodes[i]);
    }

    childNodes = node.childNodes;

    // Loop through the child nodes
    while(childNodes.length > 0)
    {
        node.removeChild(childNodes[0]);
    }
}

/////////////////////////////////////////////////////////////////////////////////

function savePrefs() {
	storeDefaults();
	saveCustoms();
}

function storeDefaults() {
	const defListObj = document.getElementById("defaultlist");	//The listbox object
	const numrows = defListObj.getRowCount();	//Get the number of rows

	var i,listItem,sename,enabled;
	for(i=0;i<numrows;i++) {
		listItem = defListObj.getItemAtIndex(i);

		sename = listItem.value;
		enabled = listItem.getAttribute("enabled")=="true"?true:false;

		ssPrefs.setBoolPref("defaults."+sename,enabled);
	}
}

function saveCustoms() {
	const customList = document.getElementById("customList");
	const numrows = customList.getRowCount();

	for (var i = numrows;i<ssPrefs.getIntPref("numengines");i++){
		ssPrefs.clearUserPref("custom."+i+".name");
		ssPrefs.clearUserPref("custom."+i+".test");
		ssPrefs.clearUserPref("custom."+i+".find");
	}

	var listItem;
	for(i=0;i<numrows;i++) {
		listItem=customList.getItemAtIndex(i);

		ssPrefs.setCharPref("custom."+i+".name",listItem.childNodes[0].getAttribute("label"));
		ssPrefs.setCharPref("custom."+i+".test",listItem.childNodes[1].getAttribute("label"));
		ssPrefs.setCharPref("custom."+i+".find",listItem.childNodes[2].getAttribute("label"));
	}

	ssPrefs.setIntPref("numengines",numrows);
}